org.cpsolver.ifs.model

## Interface Neighbour<V extends Variable<V,T>,T extends Value<V,T>>

- Type Parameters:
    `V` - Variable
    `T` - Value
  All Known Subinterfaces:
    StudentMove
  All Known Implementing Classes:
    BacktrackNeighbourSelection.BackTrackNeighbour, BranchBoundSelection.BranchBoundNeighbour, ExamRoomSwapNeighbour, ExamSimpleNeighbour, ExamSplitMoves.ExamMergeNeighbour, ExamSplitMoves.ExamShuffleNeighbour, ExamSplitMoves.ExamSplitNeighbour, LazyNeighbour, LazySwap, NeighbourSelectionWithSuggestions.SuggestionNeighbour, PriorityConstructionSelection.ConstructionNeighbour, RandomSwapMove.SwapNeighbour, RandomUnassignmentSelection.UnassignStudentNeighbour, SimpleNeighbour, StudentSwap, SwapStudentSelection.SwapStudentNeighbour

      public interface Neighbour<V extends Variable<V,T>,T extends Value<V,T>>

  IFS neighbour.
  Version:
    IFS 1.3 (Iterative Forward Search)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller
  See Also:
    `NeighbourSelection`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `assign(Assignment<V,T> assignment, long iteration)` Perform assignment
    `Map<V,T>` | `assignments()` Return assignments to be done.
    `double` | `value(Assignment<V,T> assignment)` Difference in the evaluation function, if this neighnour is assigned.

- - ### Method Detail

    - #### assign

          void assign(Assignment<V,T> assignment,
                      long iteration)

      Perform assignment
      Parameters:
        `assignment` - current assignment
        `iteration` - current iteration

    - #### value

          double value(Assignment<V,T> assignment)

      Difference in the evaluation function, if this neighnour is assigned.
      Parameters:
        `assignment` - current assignment
      Returns:
        difference in the solution value when assigned

    - #### assignments

          Map<V,T> assignments()

      Return assignments to be done.
      Returns:
        list of assignments (including unassignments) of this neighbour